#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "listedouble.h"

#define ALLOC_SIZE 10
#define HTML_START() printf( "Content-type: text/html\n\n<HTML>\n" );
#define HTML_END()   printf( "</HTML>\n" )

typedef struct
{
   char name[20];               /* BoF !! */
   char value[20];              /* BoF !! */
} var;

char *get_env (void);
int result_create (dll_s **, const char *);

int main (void)
{
   char *env = "essai=test&prog=align";
   int ret = EXIT_SUCCESS;

/*  env = get_env();*/
   if (env != NULL)
   {
      var *v;
      char old_name[20] = "";
      dll_s *p_dll = NULL;

      if (result_create (&p_dll, env) != EXIT_FAILURE)
      {
         HTML_START ();
         dll_first (&p_dll);
         while (p_dll != NULL)
         {
            v = (var *) (dll_data (p_dll));
            if (strcmp (old_name, v->name) == 0)
               printf (", ");
            else
               printf ("<br />\n%s: ", v->name);
            printf ("%s", v->value);
            strcpy (old_name, v->name);
            dll_next (&p_dll);
         }
         printf ("\n");
         free (env);
         dll_delete (&p_dll);
         HTML_END ();
      }
      else
         ret = EXIT_FAILURE;
   }
   else
      ret = EXIT_FAILURE;
   return (ret);
}

char *get_env (void)
{
   size_t size = 0;
   char *env = NULL;
   char tmp[ALLOC_SIZE + 1];

   do
   {
      char *tmp_env = NULL;

      size += ALLOC_SIZE;
      tmp_env = realloc (env, sizeof (*env) * (size + 1));
      if (tmp_env != NULL)
      {
         if (env == NULL)
            tmp_env[0] = '\0';
         env = tmp_env;
         fgets (tmp, ALLOC_SIZE + 1, stdin);
         if (tmp != NULL)
            strcat (env, tmp);
      }
      else
      {
         fprintf (stderr, "Memoire insufisante\n");
         free (tmp_env);
         break;
      }
   }
   while (tmp != NULL);
   return (env);
}

int result_create (dll_s ** pp_dll, const char *env)
{
   var *v;
   int j = 0;
   int size = strlen (env);
   int ret = EXIT_SUCCESS;

   while (j < size)
   {
      v = malloc (sizeof (*v));
      if (v != NULL)
      {
         int i = 0;

         while (j < size && env[j] != '=')
            v->name[i++] = env[j++];
         v->name[i] = '\0';
/* Pour passer le '=' */
         j++;
         i = 0;
         while (j < size && env[j] != '&')
            v->value[i++] = env[j++];
         v->value[i] = '\0';
/* Pour passe le '&' */
         j++;
         i = 0;
         dll_insert (pp_dll, (void *) v);
         if (*pp_dll == NULL)
            ret = EXIT_FAILURE;
      }
      else
      {
         fprintf (stderr, "Memoire insufisante\n");
         ret = EXIT_FAILURE;
      }
   }
   dll_first (pp_dll);
   return (ret);
}
